package pen_flowchart;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.datatransfer.StringSelection;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
import java.awt.geom.Rectangle2D;
import javax.swing.JLabel;

public abstract class DropSource extends JLabel{
	private static final long serialVersionUID = 1L;
	public static final Font tfont = new Font(Font.MONOSPACED, Font.PLAIN, 12);
	public DropSource()
	{
		super();
		int action = DnDConstants.ACTION_COPY_OR_MOVE;
		new DragSource().createDefaultDragGestureRecognizer(this, action, listener);
	}

	private DragGestureListener listener = new DragGestureListener() {
		
		@Override
		public void dragGestureRecognized(DragGestureEvent e) {
			Cursor cursor = DragSource.DefaultMoveDrop;
			StringSelection tr = new StringSelection(getString());
			e.startDrag(cursor, tr);
		}
	};
	
	abstract protected String getString();
	
	public void drawString(String s, Graphics g)
	{
		if(s == null)return;
		g.setFont(tfont);
		FontMetrics fm = g.getFontMetrics();
		Rectangle2D rect_str = fm.getStringBounds(s, g);
		Dimension rect_size = getPreferredSize();
		g.setColor(Color.WHITE);
		int x = rect_size.width / 2 - (int)(rect_str.getWidth() / 2);
		int y = rect_size.height / 2 - (int)(rect_str.getHeight() / 2);
		g.fillRect(x, y,
				(int)rect_str.getWidth(), (int)rect_str.getHeight());
		g.setColor(Color.BLACK);
		g.drawString(s, x, y + fm.getAscent());	
	}
	
}
