package pen_flowchart;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;

import org.w3c.dom.Document;
import org.w3c.dom.Element;



abstract public class Parts_LoopEnd extends Parts {
	protected int text_width, text_height;
	protected Parts_LoopBegin loopbegin;
	protected boolean hilight;

	public Parts_LoopEnd()
	{
		super();
		hilight = false;
	}

	public void setHilight(boolean b)
	{
		hilight = b;
	}

	public void setLoopBegin(Parts_LoopBegin begin)
	{
		loopbegin = begin;
	}

	public Parts_LoopBegin getLoopBegin()
	{
		return loopbegin;
	}

	abstract void setText2(String s);
	abstract String getText2();

	@Override
	public boolean isRecursiveEnd()
	{
		return true;
	}

	public boolean hasText()
	{
		return false;
	}

	@Override
	public int getHeight()
	{
		return text_height * (hasText() ? 2 : 1) + size * 2;
	}

	@Override
	public int getWidth()
	{
		return text_width + size * 2;
	}
	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int x[] = {getX1(), getX2(), getX2(), getX2() - size * 2, getX1() + size * 2, getX1()};
		int y[] = {getY1(), getY1(), getY2() - size * 2, getY2(), getY2(), getY2() - size * 2};
		g.setColor(hilight ? Color.YELLOW : Color.WHITE);
		g.fillPolygon(x, y, 6);
		g.setColor(Color.BLACK);
		if(hasText())
		{
			int ym = (getY1() + getY2()) / 2;
			drawString(getText(),g,fm,getX1(),getY1(),getX2(),ym);
			drawString(getText2(),g,fm,getX1(),ym,getX2(),getY2());
		}
		g.drawPolygon(x, y, 6);
		p.y = getY2();

//		if(getLeft() != null || getLeft().isRecursiveEnd())
//			return this;
		return getLeft().paint(g, fm, p);
	}
/*
	@Override
	public Parts paintPdf(com.itextpdf.text.pdf.PdfContentByte cb, int height, Graphics g, FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int x[] = {getX1(), getX2(), getX2(), getX2() - 10, getX1() + 10, getX1()};
		int y[] = {getY1(), getY1(), getY2() - 10, getY2(), getY2(), getY2() - 10};
		g.setColor(Color.WHITE);
		g.fillPolygon(x, y, 6);
		g.setColor(Color.BLACK);
		if(hasText())
		{
			int ym = (getY1() + getY2()) / 2;
			drawStringPdf(cb, height, getText(),g,fm,getX1(),getY1(),getX2(),ym);
			drawStringPdf(cb, height, getText2(),g,fm,getX1(),ym,getX2(),getY2());
		}
		g.drawPolygon(x, y, 6);
		p.y = getY2();

//		if(getLeft() != null || getLeft().isRecursiveEnd())
//			return this;
		return getLeft().paintPdf(cb, height, g, fm, p);
	}
*/
	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		// do nothing
		// 既にloopbeginの方でやってるから
	}

	public void setTextSize(int h, int w)
	{
		text_height = h;
		text_width = w;
	}

	@Override
	public Parts calcSize(Graphics g, FontMetrics fm, Point p, Point p1, Point p2)
	{
		setSize(g, fm);
		int x1 = p.x - getWidth() / 2 ;
		int x2 = p.x + getWidth() / 2 ;
		if(x1 < p1.x) p1.x = x1;
		if(x2 > p2.x) p2.x = x2;
		p.y += getHeight();
		p2.y += getHeight();
		setY2(p2.y);
		return getLeft().calcSize(g, fm, p, p1, p2);
	}

	@Override
	public boolean deleteMe(Flowchart chart)
	{
		return loopbegin.deleteMe(chart);
	}

	@Override
	public boolean cutMe(Flowchart chart)
	{
		return loopbegin.cutMe(chart);
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		return this;
	}
	@Override
	Parts makeXML(Document doc, Element parent) {
		return this.getLeft();
	}
}
